//
//  Controller.m
//  GoogleSearch
//
//  Created by KOYAMA Yoshiaki on 05/12/10.
//  Copyright 2005 KOYAMA Yoshiaki. All rights reserved.
//

#import "Controller.h"
#import "WSStub.h"
#import "PageElement.h"
#import "UrlElement.h"

@implementation Controller

// EBhEƂ̏
- (BOOL)windowShouldClose:(id)sender {
	[NSApp terminate:self];
    return YES;
}

- (id) init {

    if (self = [super init])
    {
		pageElements = [[NSMutableArray alloc] init];
		[pageElements autorelease];
		_maxPage = 0;
		_endIndex = 0;
		_startIndex = 0;
    }
    return self;
}

- (IBAction)doGoogleSearch:(id)sender {
	id ret;
	id array;
	NSString *url, *snippet, *title, *search;
	int count, i;
	PageElement *pageElement;
	UrlElement *urlElement;
    NSMutableArray *urlElements;

	search = [_searchField stringValue];

	if ([search isEqualToString:@""] == YES) {
		[self printIndex];
		return;
	}
	
	[_indicator startAnimation:self];

	_startIndex = 0;
	ret = [GoogleSearchService doGoogleSearch:REGISTRATION_KEY in_q:search in_start:0  in_maxResults:10 in_filter:NO in_restrict:@"" in_safeSearch:NO in_lr:@"lang_ja" in_ie:@"UTF-8" in_oe:@"UTF-8"];

	[_indicator stopAnimation:self];

//	NSLog(@"class = %@", [ret class]);
//	NSLog(@"%@", ret);

	_endIndex =	[[ret objectForKey:@"endIndex"] intValue];
	_estimatedTotalResultsCount = [[ret objectForKey:@"estimatedTotalResultsCount"] intValue];

//NSLog(@"endIndex = %d : estimatedTotalResultsCount = %d", _endIndex, _estimatedTotalResultsCount);


	pageElements = [[NSMutableArray alloc] init];
	[pageElements autorelease];

/*	if (_estimatedTotalResultsCount == 0) {
		[_pageElementController setContent:pageElements];
		return;
	}
*/
	_maxPage = 1;
	pageElement = [[PageElement alloc] initPage: 1];
	[pageElement autorelease];
	[pageElements addObject:pageElement];

	urlElements = [pageElement urlElements];

	array = [ret objectForKey:@"resultElements"];

	if (array != nil) {
		count = [array count];
		_startIndex += count;
	}

	for (i=0; i<count; i++) {
		url = [[array objectAtIndex:i] objectForKey:@"URL"];
		snippet = [[array objectAtIndex:i] objectForKey:@"snippet"];
		title = [[array objectAtIndex:i] objectForKey:@"title"];

		if ([[url className] isEqualToString:@"NSNull"] == YES)
			url = @"";
		if ([[snippet className] isEqualToString:@"NSNull"] == YES)
			snippet = @"";
		if ([[title className] isEqualToString:@"NSNull"] == YES)
			title = @"";

		urlElement = [[UrlElement alloc] initUrlElement:url :snippet :title];
		[urlElement autorelease];

		[urlElements addObject:urlElement];

//		NSLog(@"url: %@", url);
//		NSLog(@"snipper: %@", snippet);
	}

	[_pageElementController setContent:pageElements];

	[self printIndex];
}

- (IBAction)doLeftGoogleSearch:(id)sender {
	unsigned int uindex;
	unsigned umax;

	uindex = [_pageElementController selectionIndex];
	umax = [[_pageElementController arrangedObjects] count];

	if (umax == 0)
		return;

	if (uindex == NSNotFound) {
		[self printIndex];
		return;
	}
	
	if (uindex > 0) {
		[_pageElementController setSelectionIndex:(uindex-1)];
		[self printIndex];
	}
}

- (IBAction)doRightGoogleSearch:(id)sender {
	id ret;
	id array;
	NSString *url, *snippet, *title;
	int count, i;
	PageElement *pageElement;
	UrlElement *urlElement;
    NSMutableArray *urlElements;
	unsigned int uindex;
	unsigned umax;

	uindex = [_pageElementController selectionIndex];
	umax = [[_pageElementController arrangedObjects] count];

//	NSLog(@"index = %d/%d", uindex, umax);

	if (umax == 0)
		return;

	if (uindex < (umax -1)) {
		[_pageElementController setSelectionIndex:(uindex+1)];
		[self printIndex];
		return;
	}

	if ((umax*10) >= _estimatedTotalResultsCount)
		return;

	[_indicator startAnimation:self];

	_maxPage++;
	ret = [GoogleSearchService doGoogleSearch:REGISTRATION_KEY in_q:[_searchField stringValue] in_start:_startIndex in_maxResults:10 in_filter:NO in_restrict:@"" in_safeSearch:NO in_lr:@"lang_ja" in_ie:@"UTF-8" in_oe:@"UTF-8"];

	[_indicator stopAnimation:self];

//	NSLog(@"class = %@", [ret class]);
//	NSLog(@"%@", ret);

	pageElement = [[PageElement alloc] initPage: _maxPage];
	[pageElement autorelease];
//	[pageElements addObject:pageElement];

	urlElements = [pageElement urlElements];
	
//	_endIndex =	[[ret objectForKey:@"endIndex"] intValue];

	array = [ret objectForKey:@"resultElements"];
	if (array != nil) {
		count = [array count];
		_startIndex += count;
	}
	
	for (i=0; i<count; i++) {
		url = [[array objectAtIndex:i] objectForKey:@"URL"];
		snippet = [[array objectAtIndex:i] objectForKey:@"snippet"];
		title = [[array objectAtIndex:i] objectForKey:@"title"];

		if ([[url className] isEqualToString:@"NSNull"] == YES)
			url = @"";
		if ([[snippet className] isEqualToString:@"NSNull"] == YES)
			snippet = @"";
		if ([[title className] isEqualToString:@"NSNull"] == YES)
			title = @"";
		
		urlElement = [[UrlElement alloc] initUrlElement:url :snippet :title];
		[urlElement autorelease];

		[urlElements addObject:urlElement];

//		NSLog(@"url: %@", url);
//		NSLog(@"title: %@", title);
//		NSLog(@"snipper: %@", snippet);
	}

//	[_pageElementController setContent:pageElements];
//	[[_pageElementController content] addObject:pageElement];
//	[pageElements addObject:pageElement];
	[_pageElementController addObject:pageElement];
	[self printIndex];
}

- (void)printIndex {
	NSString *str;
	unsigned int uindex, index;
	unsigned umax, count;
	id array;
	int total, i;

	uindex = index = umax = count = total = 0;

	uindex = [_pageElementController selectionIndex];
	umax = [[_pageElementController arrangedObjects] count];
	count = [[_urlElementController arrangedObjects] count];

	array = [_pageElementController arrangedObjects];

	if (uindex == NSNotFound) {
		index = 0;
	} else {
		index = uindex;
	}
	
	for (i=0; i<index; i++) {
		total += [[[array objectAtIndex:i] urlElements] count];
	}

//NSLog(@"%@", [[_pageElementController arrangedObjects] className]);
//NSLog(@"endIndex = %d : estimatedTotalResultsCount = %d", _endIndex, _estimatedTotalResultsCount);

	if (_estimatedTotalResultsCount == 0) {
		str = @"0-0/0000";
	} else if ((umax == 0) || (uindex == NSNotFound)) {
		str = @"0-0/0000";
	} else {
		str = [NSString stringWithFormat:@"%d-%d/%d", total+1, total+count, _estimatedTotalResultsCount];
	}
	
	[_textField setStringValue:str];
}

@end
